// ServerDlg.h : header file
//

#if !defined(AFX_SERVERDLG_H__CA1A81DF_51D8_4C31_9403_20AF81F15FE0__INCLUDED_)
#define AFX_SERVERDLG_H__CA1A81DF_51D8_4C31_9403_20AF81F15FE0__INCLUDED_

#pragma warning(disable: 4786)
#import "..\..\..\..\common\VCProX.ocx"
using namespace VCProX;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const IID IID_IIpServerEventSink = __uuidof(IvcproIpServerEvents);

class CIpServerEventSink : public CCmdTarget
{
public:
	HWND m_DialogHWND;					 
	CIpServerEventSink();
	//virtual ~CIpServerEventSink();

protected:
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CIpServerEventSink)
	afx_msg void OnClientConnect(long ConnId);
	afx_msg void OnClientDisconnect(long ConnId);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CServerDlg dialog

class CServerDlg : public CDialog
{
// Construction
public:
	CServerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CServerDlg)
	enum { IDD = IDD_SERVER_DIALOG };
	CEdit	m_Log;
	CComboBox	m_ListenerProto;
	CComboBox	m_SpeakerProto;
	CButton	m_StopServer;
	CButton	m_StartServer;
	CString	m_SpeakerPortStr;
	CString	m_ListenerPortStr;
	CString	m_NumClients;
	CString	m_SpeakerStatus;
	CString	m_ListenerStatus;
	CString	m_BytesReceived;
	CString	m_BytesSent;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CServerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	//IvcproIpServerXPtr m_serverSpeak, m_serverListen;
	HexComPtr<HEX_IIID(IvcproIpServerX)> m_serverSpeak, m_serverListen;

	CIpServerEventSink m_ServerSink;
	LPUNKNOWN m_pUnkSink;
	DWORD m_dwCookie;

	void SetLink(IvcproProviderPtr provider, IvcproConsumerPtr consumer);
	void VCInit();
	void VCUninit();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVERDLG_H__CA1A81DF_51D8_4C31_9403_20AF81F15FE0__INCLUDED_)
